
Multibutton = Core.class(Sprite)

function Multibutton:init(text,x,y,scale,up,down,scale)
	self.upState = up
	self.downState = down
	
	self:setPosition(x,y)
	self:setScale(scale,scale)
	--fonts and lables
	local font = TTFont.new("arial.ttf", 20)				-- this is TTFont without caching
	--FONT FOR CHANGE
	
	
	label = TextField.new(font, text)
	label:setTextColor(0xff6090)
	LHeight = label:getHeight()
	LWidth = label:getWidth()
	BHeight = self.upState:getHeight(self.upState)
	BWidth = self.upState:getWidth(self.upState)
	label:setPosition(x + (((BWidth * scale) / 2) - (LWidth / 2)),y + (((BHeight * scale) / 2) + (LHeight / 2)))
	--label:setPosition(x + (((self.upState:getWidth(self.upState) * scale) / 2)) - (label:getWidth() / 2) , y + (self.upState:getHeight(self.upState) * scale) - (label:getHeight() / 2))
	--label:setPosition(x + (((self.upState:getWidth(self.upState) * scale) / 2)) - (label:getWidth() / 2) , x + (self.upState:getHeight(self.upState) * scale) / 2 - ((label:getheight()) / 2))
	print(label:getHeight())
	
	self.focus = false
	self:updateVisualState(false)
	self:addEventListener(Event.MOUSE_DOWN, self.onMouseDown, self)
	self:addEventListener(Event.MOUSE_MOVE, self.onMouseMove, self)
	self:addEventListener(Event.MOUSE_UP, self.onMouseUp, self)

	stage:addChild(self)
	stage:addChild(label)
end

function Multibutton:create(text,x,y,scale)


array = {
["ID"] = {},
["upState"] = {},
["downState"] = {},
["X"] = {},
["Scale"] = {}
	}
	
	
	
newx = x;
newy = y;
print(#text)


for i = 1, #text, 1 do
	local S = {Bitmap.new(Texture.new("start_up.png")),Bitmap.new(Texture.new("start_down.png"))}
	local M = {Bitmap.new(Texture.new("mid_up.png")),Bitmap.new(Texture.new("mid_down.png"))}
	local E = {Bitmap.new(Texture.new("end_up.png")),Bitmap.new(Texture.new("end_down.png"))}

	array["ID"][i] = i;
	array["upState"][i] = M[1]; array["downState"][i] = M[2];
	if i == 1 then array["upState"][i] = S[1]; array["downState"][i] = S[2] end
	if i == #text then array["upState"][i] = E[1]; array["downState"][i] = E[2] end
	array["X"][i] = newx
	print(array["ID"][i],array["X"][i],array["upState"][i])
	
	array["ID"][i] = Multibutton.new(text[i],array["X"][i],y,1,array["upState"][i],array["downState"][i],scale)
	
	array["ID"][i]:addEventListener("click", 
	function() 
		multi_click(i)
	end)
	
	newx = newx + (array["upState"][i]:getWidth(array["upState"][i]) * scale) - 1
end	
end

function Multibutton:onMouseDown(event)
	if self:hitTestPoint(event.x, event.y) then
		self.focus = true
		self:updateVisualState(true,array)
		event:stopPropagation()
	end
end

function Multibutton:onMouseMove(event)
	if self.focus then
		if not self:hitTestPoint(event.x, event.y) then	
			self.focus = false
			self:updateVisualState(false,array)
		end
		event:stopPropagation()
	end
end

function Multibutton:onMouseUp(event)
	if self.focus then
		self.focus = false
		self:updateVisualState(false,array)
		self:dispatchEvent(Event.new("click"))	-- button is clicked, dispatch "click" event
		event:stopPropagation()
	end
end


function Multibutton:updateVisualState(state)
--for i = 1, #array, 1 do
--print("hi",#array)

if state then
		if self:contains(self.upState) then
			self:removeChild(self.upState)
		end
		
		if not self:contains(self.downState) then
			self:addChild(self.downState)
		end
	else
		if self:contains(self.downState) then
			self:removeChild(self.downState)
		end
		
		if not self:contains(self.upState) then
			self:addChild(self.upState)
		end
	end
end

